...
1#!/usr/bin/env bash
2
3# Copyright 2024 The Kubernetes Authors.
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17set -o errexit
18set -o nounset
19set -o pipefail
20
21function usage {
22 local script="$(basename $0)"
23
24 echo >&2 "Usage: ${script} <maximum go directive>
25This script should be run at the root of a module.
26
27Compare the go directive in the local working copy's go.mod
28to the specified maximum version it can be. Versions provided
29here are of the form 1.x.y, without the 'go' prefix.
30Examples:
31 ${script} 1.20
32 ${script} 1.21.6
33"
34 exit 1
35}
36
37max="$1"
38# If max is empty, print usage and error
39if [[ -z "${max}" ]]; then
40 usage;
41fi
42
43# Don't specify the version with the go prefix, just 1.x.y will do.
44if [[ ! "${max}" =~ ^[0-9]\.[0-9]+(\.[0-9]+)?$ ]]; then
45 usage
46fi
47
48current=$(awk '/^go / {print $2;}' go.mod)
49if [[ -z "${current}" ]]; then
50 echo >&2 "FAIL: could not get value of go directive from go.mod"
51 exit 1
52fi
53
54if ! printf '%s\n' "${current}" "${max}" | sort --check=silent --version-sort; then
55 echo >&2 "FAIL: current Go directive ${current} is greater than ${max}"
56 exit 1
57fi
View as plain text